!
! store here all data you need to calculate yout function value
!
module commdata
 use methgimod
 type(meth_type) :: mdata
!
! your data come hereafter...
! ...
 integer :: n11,n12,n13,n14,n22,n23,n24,n33,n34,n44
end module commdata

!
! simple example of the MAIN module
!
program testmethgi
 use methgimod
 use commdata
 interface
  subroutine calclh(LH)
   double precision, intent(OUT) :: LH
  end subroutine calclh
 end interface

 character(1000) :: templine

 mdata=meth_loadparam('params.inp')   	!load parameters from 'params.inp'
 open(1,file='data.dat')
 read(1,*) templine
 read(1,*) n11,n12,n13,n14,n22,n23,n24,n33,n34,n44
 print  *, n11,n12,n13,n14,n22,n23,n24,n33,n34,n44
 close(1)
 call methgi(mdata,calclh)              !maximize function
 call meth_writeparam('params.out',mdata)!write estimates to 'params.out'

end program testmethgi

!
! simple example of function under maximization
!
subroutine calclh(LH)
 use commdata
 double precision, intent(OUT) :: LH
 double precision :: p1,p2,p3,p4,pr11,pr12,pr13,pr14,pr22,pr23,pr24,pr33,pr34,pr44
 a=meth_checkparam(mdata)
 if (a.lt.-1.) then;LH=a;return;endif;
 p1=mdata%param(1)%pr
 p2=mdata%param(2)%pr
 p3=mdata%param(3)%pr
 p4=1.-p1-p2-p3
 if(p4.le.EPS)then;lh=NEGLILH;return;endif;
 pr11=p1*p1;pr12=2.*p1*p2;pr13=2.*p1*p3;pr14=2.*p1*p4;pr22=p2*p2;
 pr23=2.*p2*p3;pr24=2.*p2*p4;pr33=p3*p3;pr34=2.*p3*p4;pr44=p4*p4
 lh=n11*dlog(pr11)+n12*dlog(pr12)+n13*dlog(pr13)+n14*dlog(pr14)&
&  +n22*dlog(pr22)+n23*dlog(pr23)+n24*dlog(pr24)&
&  +n33*dlog(pr33)+n34*dlog(pr34)&
&  +n44*dlog(pr44)
 print *,'fcall: ',mdata%nfun,'; LH=',lh
end subroutine calclh

